# !/bin/bash

scriptPath=$(pwd)
arch=$(uname -m)

if [ "$(whoami)" = "root" ]; then
  echo "Error: You are not supposed to run this script as root!";
  exit 1;
fi

echo -n "[sudo] password for $(whoami): "
read -s sudoPasswd
echo

while read -r pkg
do
    echo "Installing package: $pkg ..."
    echo "${sudoPasswd}" | sudo -S -v
    sudo -S apt-get install -y "$pkg"
    [ $? -eq 0 ] && { continue; }
done < packages

echo "Setting up environment..."
echo "export UIMA_WORKSPACE="$ROS_WORKSPACE"/uima" >> ~/.bashrc
. ~/.bashrc
echo "export UIMA_HOME="$UIMA_WORKSPACE"/apache-uima" >> ~/.bashrc
echo "export UIMACPP_HOME="$UIMA_WORKSPACE"/uimacpp/install" >> ~/.bashrc
. ~/.bashrc
echo "export PATH="$PATH":"$UIMACPP_HOME"/bin:"$UIMA_WORKSPACE"/apache-uima/bin" >> ~/.bashrc
echo "export LD_LIBRARY_PATH="$LD_LIBRARY_PATH":$UIMACPP_HOME/lib:$UIMA_WORKSPACE/ias-uima-cpp/lib" >> ~/.bashrc
echo "export CLASSPATH="$UIMA_WORKSPACE"/ias-uima-java/build" >> ~/.bashrc

echo "export APR_HOME=/usr" >> ~/.bashrc
echo "export ICU_HOME=/usr" >> ~/.bashrc
echo "export XERCES_HOME=/usr" >> ~/.bashrc


if [ "$arch" == "x86_64" ]
then
  echo "export JAVA_HOME=/usr/lib/jvm/java-7-openjdk-amd64/" >> ~/.bashrc
else
  echo "export JAVA_HOME=/usr/lib/jvm/java-7-openjdk-i386/" >> ~/.bashrc
fi
. ~/.bashrc
echo "export JAVA_INCLUDE=$JAVA_HOME/include" >> ~/.bashrc
. ~/.bashrc

mkdir -p $UIMA_WORKSPACE/

echo "Getting uimacpp..."
cd $UIMA_WORKSPACE
svn co https://svn.apache.org/repos/asf/uima/uimacpp/trunk/ uimacpp

cd /usr/lib
sudo ln -s libapr-1.so libapr-1.0.so

cd $UIMA_WORKSPACE/uimacpp
./autogen.sh
./configure --without-activemq --with-jdk=/usr/lib/jvm/java-7-openjdk-amd64/include --prefix=${UIMACPP_HOME}
make install

echo "Getting UIMA Java SDK..."
cd $scriptPath
wget -v http://mirror.softaculous.com/apache//uima//uimaj-2.4.0/uimaj-2.4.0-bin.tar.gz
tar -C $UIMA_WORKSPACE/ -zxvf uimaj-2.4.0-bin.tar.gz --overwrite 

cd $ROS_WORKSPACE
wget 

echo "Merging .rosinstall files..."
rosws merge $scriptPath/rosinstall

echo "rosws update ..."
roscd
rosws update

source ~/.bashrc

roscd ias-uima-cpp/../
git submodule init
git submodule update
git checkout experimental

roscd icf_dataset
touch manifest.xml.tmp
while read -r mani
do
    if [ "$mani" == "<depend package=\"eigen\"/>" ]
    then
      echo "<rosdep name=\"eigen\"/>" >> manifest.xml.tmp
    else
      echo $mani >> manifest.xml.tmp
    fi
    [ $? -eq 0 ] && { continue; }
done < manifest.xml
mv manifest.xml.tmp manifest.xml

echo "find_package(Eigen REQUIRED)" >> CMakeLists.txt
echo "include_directories(${EIGEN_INCLUDE_DIRS})" >> CMakeLists.txt
echo "add_definitions(${EIGEN_DEFINITIONS})" >> CMakeLists.txt

rosdep update

cd $scriptPath
while read -r mkP
do
    echo "rosmake: $mkP ..."
    rosmake "$mkP"
    [ $? -eq 0 ] && { continue; }
done < makepackages

echo "Compiling ias-uima-java..."
cd $UIMA_WORKSPACE/ias-uima-java-ant
ant
roscd ias-uima-cpp
cmake -G"Eclipse CDT4 - Unix Makefiles" -D CMAKE_BUILD_TYPE=Debug .
echo "UIMA setup completed"
echo "Now import existing Eclipse Project (ias-uima-cpp) into Eclipse CDT and write your annotators"
